config/routes.rb
Rails.application.routes.draw do

  get 'torres/index'

  get 'personas/index'

  resources :torres do
      resources :aptos do
        resources :personas

      end

    end
  root 'torres#index'

end

app/models/apto.rb
class Apto < ActiveRecord::Base
  belongs_to :torre
end

app/models/persona.rb
class Persona < ActiveRecord::Base
  belongs_to :apartamento
end

app/models/torre.rb
class Torre < ActiveRecord::Base
  has_many :aptos
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/aptos_controller.rb
class AptosController < ApplicationController


  def new

      @torre= Torre.find(params[:torre_id])
      @apto= @torre.aptos.new

  end

  def edit

    @torre = Torre.find(params[:torre_id])
    @apto = @torre.aptos.find(params[:id])

  end

  def show

        @torre = Torre.find(params[:torre_id])
        @apto= @torre.aptos.find(params[:id])
        @var2 = Apto.find(params[:id])

  end

  def create
      @torre= Torre.find(params[:torre_id])
      apto=@torre.aptos.new(apto_params)
      apto.save
      redirect_to torre_path(@torre)
  end


  def update

    @apto = Apto.find(params[:id])
    @apto.update(apto_params)
    redirect_to torre_apto_path(@apto.torre, @apto)

  end



  def destroy

  @apto = Apto.find(params[:id])
  @apto.destroy
  redirect_to torre_path(@apto.torre)

  end


private
def apto_params
    params.require(:apto).permit(:nombre,:piso,:torre_id, :id)
end

end

app/controllers/personas_controller.rb
class PersonasController < ApplicationController

  def index
    @torre = Torre.find(params[:torre_id])
    @apto = Apto.find(params[:apto_id])
    @personas = Persona.all
  end

  def new
        @torre = Torre.find(params[:torre_id])
        @apto = Apto.find(params[:apto_id])
        @persona = Persona.new
  end

  def create
        @torre = Torre.find(params[:torre_id])
        @apto = Apto.find(params[:apto_id])
        @persona= Persona.new(persona_params)
        @persona.save
        redirect_to torre_apto_personas_path(@apto.torre, @apto)
  end

  def edit

    @torre = Torre.find(params[:torre_id])
    @apto = Apto.find(params[:apto_id])
    @persona= @apto.personas.find(params[:id])



  end

  def update

    @persona = Persona.find(params[:id])
    @persona.update(apto_params)
    redirect_to torre_apto_path(@apto.torre, @apto)

  end

  def destroy

  @persona = Persona.find(params[:id])
  @persona.destroy
  redirect_to torre_index_path()

  end

  private
  def persona_params
        params.require(:persona).permit(:nombre, :identificacion, :apto_id, :torre_id)
  end


end

app/controllers/torres_controller.rb
class TorresController < ApplicationController

  def index
    @torres = Torre.all
  end

  def new
        @torre = Torre.new
  end

  def create
        @torre= Torre.new(torre_params)
        @torre.save
        redirect_to torres_path
  end

  def edit

  @torre = Torre.find(params[:id])


  end

  def show

    @torre = Torre.find(params[:id])
    @idapto = Apto.find(params[:id])
    @aptos = @torre.aptos.all

  end

  def update

  @torre = Torre.find(params[:id])
  @torre.update(torre_params)
  redirect_to torres_path

  end


  def destroy
      @torre = Torre.find(params[:id])
      @torre.destroy
      redirect_to torres_path
  end

  private
  def torre_params
        params.require(:torre).permit(:nombre, :portero, :id)
  end


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/aptos_helper.rb
module AptosHelper
end

app/helpers/persona_helper.rb
module PersonaHelper
end

app/helpers/torres_helper.rb
module TorresHelper
end

app/views/aptos/edit.html.erb
<div class="container">

<h2><form class="form-signin"  method="post">Llene los campos</h2></form>


<%= form_for [@apto.torre, @apto] do |a| %>
  <div class="row">


    <div class="col-md-4">



    </div>
    <div class="col-md-4">

      <%= a.text_field :nombre,  :placeholder => "Nombre", :class => "form-control col-sm-2"%> <br>


    </div>
    <div class="col-md-4">



    </div>


  </div><br><br>

<div class="row">

  <div class="col-md-4">



  </div>
  <div class="col-md-4">

    <%= a.text_field :piso, :placeholder => "Piso", :class => "form-control col-sm-2" %> <br>


  </div>
  <div class="col-md-4">



  </div>


  </div>

<br><br>
  <div class="row">

    <div class="col-md-4">



    </div>
    <div class="col-md-4">

          <center>  <%=a.collection_select :torre_id, Torre.all, :id, :nombre,{}, {class: "form-control"}%><br>
            <%= a.submit 'Guardar',  class:"btn btn-large btn-primary"%>

          <%=link_to '<button type="button" class="btn btn-large btn-primary">Regresar</button>'.html_safe, torres_path%>
        </center>





    </div>
    <div class="col-md-4">


    </div>




  </div>

    <% end %>






</div>

app/views/aptos/new.html.erb
<div class="container">

<h2><form class="form-signin"  method="post">Llene los campos</h2></form>


<%= form_for [@apto.torre, @apto] do |a| %>
  <div class="row">


    <div class="col-md-4">



    </div>
    <div class="col-md-4">

      <%= a.text_field :nombre,  :placeholder => "Nombre", :class => "form-control col-sm-2"%> <br>


    </div>
    <div class="col-md-4">



    </div>


  </div><br><br>

<div class="row">

  <div class="col-md-4">



  </div>
  <div class="col-md-4">

    <%= a.text_field :piso, :placeholder => "Piso", :class => "form-control col-sm-2" %> <br>


  </div>
  <div class="col-md-4">



  </div>


  </div>

<br><br>
  <div class="row">

    <div class="col-md-4">



    </div>
    <div class="col-md-4">

          <center>  <%=a.collection_select :torre_id, Torre.all, :id, :nombre,{}, {class: "form-control"}%><br>
            <%= a.submit 'Guardar',  class:"btn btn-large btn-primary"%>

          <%=link_to '<button type="button" class="btn btn-large btn-primary">Regresar</button>'.html_safe, torres_path%>
        </center>





    </div>
    <div class="col-md-4">


    </div>




  </div>

    <% end %>






</div>

app/views/aptos/show.html.erb
<h1>Apartamento: <%=@apto.nombre %></h1>
<h1>Piso: <%=@apto.piso %> </h1>
<p></p><br>

<center>
<%=link_to '<i class="fa fa-pencil fa-3x"></i>'.html_safe, edit_torre_apto_path(@apto.torre, @apto) %>
<%=link_to '<i class="fa fa-users fa-3x"></i>'.html_safe, torre_apto_personas_path(@torre, @var2) %>
<%= link_to '<i class="fa fa-remove fa-3x"></i>'.html_safe, @aptos, method: :delete, data: {confirm: "Are you sure?"} %>
<br><br>
<%=link_to '<i class="fa fa-reply fa-3x"></i>'.html_safe, torre_path(@torre)%>
</center>

app/views/layouts/_header.html.erb
<header class="navbar navbar-fixed-top navbar-default">
 <div class="container">
   <%= link_to "Torres", torres_path, id: "logo" %>
   <nav>
     <ul class="nav navbar-nav navbar-right">
       <li><%= link_to "Home",   '#' %></li>
       <li><%= link_to "Help",   '#' %></li>
       <li><%= link_to "Log in", '#' %></li>
     </ul>
   </nav>
 </div>
</header>

app/views/layouts/_torreForm.html.erb
<div class="container">

<h2><form class="form-signin"  method="post">Llene los campos</h2></form>


  <%= form_for @torre do |t| %>
  <div class="row">


    <div class="col-md-4">



    </div>
    <div class="col-md-4">

      <%= t.text_field :nombre,:placeholder => "Nombre", :class => "form-control col-sm-2"%>


    </div>
    <div class="col-md-4">



    </div>


  </div><br><br>

<div class="row">

  <div class="col-md-4">



  </div>
  <div class="col-md-4">

    <%= t.text_field :portero,:placeholder => "Portero", :class => "form-control col-sm-2"%>


  </div>
  <div class="col-md-4">



  </div>


  </div>

<br><br>
  <div class="row">

    <div class="col-md-4">



    </div>
    <div class="col-md-4">

          <center><%= t.submit 'Guardar', class:"btn btn-large btn-primary"%>
          <%=link_to '<button type="button" class="btn btn-large btn-primary">Regresar</button>'.html_safe, torres_path%>
        </center>





    </div>
    <div class="col-md-4">


    </div>




  </div>

    <% end %>






</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Blog</title>
  <%= render 'layouts/header' %>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>



<%= yield %>

</body>
</html>

app/views/personas/edit.html.erb
<h1>editemos pues</h1>

<%= form_for [@torre, @apto, @persona] do |a| %>

<p>
  <%= a.label :nombre %> <br>
  <%= a.text_field :nombre %> <br>
  <%= a.label :identificacion %> <br>
  <%= a.text_field :identificacion %> <br>
  <%=a.collection_select :apartamento_id, Apto.all, :id, :nombre%>


</p>

<p>
<%= a.submit %>
</p>

<% end %>

app/views/personas/index.html.erb
<div class="header">
  <h1>Habitantes del apartamento:  <%= @apto.nombre %></h1>
</div>

	<div class="container">

<%=link_to'<i class="fa fa-plus fa-3x"></i>'.html_safe, new_torre_apto_persona_path(@torre, @apto)%>


				<table class="table table-hover">
					<thead>
						<tr>

								<th><h3>Nombre </h3></th>
								<th><h3>Identificación </h3></th>
					</tr>

					</thead>
					<tbody>

<% @personas.each do |persona| %>
    <tr>

    <td><%= persona.nombre %><td>
    <td><%= persona.identificacion %><td>
    <td><%= link_to '<i class="fa fa-remove  fa-3x aria-hidden="true" "></i>'.html_safe,  (@persona), method: :delete, data: {confirm: "Are you sure?"} %><td>
    <td><%=link_to  '<i class="fa fa-pencil fa-3x"></i>'.html_safe, edit_torre_apto_persona_path(@torre, @apto, persona)%><td>






				</tr>
				<% end %>

			</table>

app/views/personas/new.html.erb
<h1>Añadir habitante</h1>
<%= form_for  [@torre, @apto, @persona] do |f| %>
<%=f.label :nombre %>
<%=f.text_field :nombre %>
<%=f.label :identificacion %>
<%=f.text_field :identificacion %>
<%=f.collection_select :apto_id, Apto.all, :id, :nombre%>
<%=f.submit %>
<%end%>

app/views/torres/edit.html.erb
<h1>Actualizar datos</h1>
<%= render 'layouts/torreForm' %>

app/views/torres/index.html.erb
<div class="header">
	<h1>Lista de torres</h1>
</div>
			<div class="container">

				<%=link_to '<i class="fa fa-plus fa-3x"></i>'.html_safe, new_torre_path%>

				<table class="table table-hover">
					<thead>
						<tr>

								<th><h3>Nombre </h3></th>
								<th><h3>Portero </h3></th>
					</tr>

					</thead>
					<tbody>

				<% @torres.each do |torre| %>
					<tr>


					<td><%= torre.nombre %></td>
					<td><%= torre.portero %></td>
					<td><%=link_to '<i class="fa fa-pencil fa-3x"></i>'.html_safe, edit_torre_path(torre)%></td>
					<td><%=link_to '<i class="fa fa-info fa-3x"></i>'.html_safe, torre_path(torre) %></td>
					<td><%= link_to '<i class="fa fa-remove  fa-3x aria-hidden="true" "></i>'.html_safe, torre, method: :delete, data: {confirm: "Are you sure?"} %></td>



				</tr>
				<% end %>

			</table>

app/views/torres/new.html.erb
<h1>Añadir una torre</h1>
<%= render 'layouts/torreForm' %>

app/views/torres/show.html.erb
<div class="header">
<h1>Información de la torre: <%=@torre.nombre %></h1>
</div>
			<div class="container">

        <%=link_to '<i class="fa fa-reply fa-3x"></i>'.html_safe, torres_path()%>
				<%=link_to '<i class="fa fa-plus fa-3x"></i>'.html_safe, new_torre_apto_path(@torre)%>

				<table class="table table-hover">
					<thead>
						<tr>
								<th><h3>Nombre </h3></th>
								<th><h3>Piso </h3></th>
					</tr>

					</thead>
					<tbody>

				<% @aptos.each do |t| %>
					<tr>


          <td><%= t.nombre %></td>
          <td>
              <%= t.piso %>
          </td>
          <td>  <%=link_to '<i class="fa fa-info fa-3x"></i>'.html_safe, torre_apto_path(@torre, t)%></td>



				</tr>
				<% end %>



			</table>